﻿use math as m

function Conjugate(a)
ret=[[0],[0],[0],[0]];
ret[0][0]= (a[0][0]);
ret[1][0]= (-a[1][0]);
ret[2][0]= (-a[2][0]);
ret[3][0]= (-a[3][0]);
return ret;
end;

function Len(a)
len=m.sqrt(a[0][0]*a[0][0]+a[1][0]*a[1][0]+a[2][0]*a[2][0]+a[3][0]*a[3][0]);
return len;
end;

function Inverse(a)
temp=1/(Len(a)*Len(a));
ret=
[
[a[0][0]*temp],
[a[1][0]*temp],
[a[2][0]*temp],
[a[3][0]*temp]
];

return ret;
end;

function Normalize(a)
l=Len(a);
for i=0 to len(a)-1 do
a[i][0]=a[i][0]/l;
end;
return a;
end;

function Prod(a,b)

p=[

[a[0][0]*b[0][0]-a[1][0]*b[1][0]-a[2][0]*b[2][0]-a[3][0]*b[3][0]],

[a[0][0]*b[1][0]+a[1][0]*b[0][0]+a[2][0]*b[3][0]-a[3][0]*b[2][0]],

[a[0][0]*b[2][0]-a[1][0]*b[3][0]+a[2][0]*b[0][0]+a[3][0]*b[1][0]],

[a[0][0]*b[3][0]+a[1][0]*b[2][0]-a[2][0]*b[1][0]+a[3][0]*b[0][0]]
];
return p;
end;


function getRotationQuat(ang,k)
//ang=angle,k=axis

q=[
[m.cos(ang/2)],
[m.sin(ang/2)*k[0][0]],
[m.sin(ang/2)*k[1][0]],
[m.sin(ang/2)*k[2][0]]
];
return q;
end;

