﻿use time, graph as g, math as m,matrixUtil as ma,Quaternions as q
cls();


runtime=50;
g.pen(g.white);
g.size(g.full(true)[0],g.full(true)[1]);
g.bg(0);
g.clear();
sx=g.full(true)[0]/2;
sy=g.full(true)[1]/2;


points=[];
for i=0 to 500 do
temp=ma.zeros(3,1);
temp[0][0]=m.random()*150-75;
temp[1][0]=m.random()*150-75;
temp[2][0]=m.random()*150-75;
append(points,temp);
end;

k1=[[1],[0],[0]];//x
k2=[[0],[1],[0]];//y
k3=[[0],[0],[1]];//z

k=[[1/m.sqrt(3)],[1/m.sqrt(3)],[1/m.sqrt(3)]];

th=m.pi/50;

//R=ma.genRot([[1/m.sqrt(3)],[1/m.sqrt(3)],[1/m.sqrt(3)]],th);
R=ma.genRot(k,th);


t=0;
t1=time.get();
while t<runtime/5 do
t++;

g.text(20,20,'algorithm 1');

for i=0 to len(points)-1 do
points[i]=ma.matrixMul(R,points[i]);
end;

for i=0 to len(points)-1 do
g.put(
sx+points[i][0][0],
sy+points[i][1][0],
g.white);
end;

g.show();
sleep(0);
g.clear();
end;
t2=time.get();
print 'algorithm one',(t2-t1)*5;


t=0;

t1=time.get();
while t<runtime do
t++;
g.text(20,20,'algorithm 2');
k1=ma.matrixMul(R,k1);
k2=ma.matrixMul(R,k2);
for i=0 to len(points)-1 do
g.put(
sx+ma.dotprod(points[i],k1),
sy+ma.dotprod(points[i],k2),
g.white);
end;

g.show();
sleep(0);
g.clear();
end;


t2=time.get();
print 'algorithm two',t2-t1;


k11=k1[0][0];
k12=k1[1][0];
k13=k1[2][0];

k21=k2[0][0];
k22=k2[1][0];
k23=k2[2][0];

r11=R[0][0];
r12=R[0][1];
r13=R[0][2];
r21=R[1][0];
r22=R[1][1];
r23=R[1][2];
r31=R[2][0];
r32=R[2][1];
r33=R[2][2];

//all method bodies written out

t=0;

t1=time.get();
while t<runtime do
t++;
g.text(20,20,'algorithm 3');

k11n=r11*k11+r12*k12+r13*k13;
k12n=r21*k11+r22*k12+r23*k13;
k13n=r31*k11+r32*k12+r33*k13;

k21n=r11*k21+r12*k22+r13*k23;
k22n=r21*k21+r22*k22+r23*k23;
k23n=r31*k21+r32*k22+r33*k23;

k11=k11n;
k12=k12n;
k13=k13n;

k21=k21n;
k22=k22n;
k23=k23n;

for i=0 to len(points)-1 do
g.put(
sx+points[i][0][0]*k11+points[i][1][0]*k12+points[i][2][0]*k13,
sy+points[i][0][0]*k21+points[i][1][0]*k22+points[i][2][0]*k23,
g.white);
end;

g.show();
sleep(0);
g.clear();

end;

t2=time.get();
print 'algorithm three',t2-t1;

t=0;


q=q.getRotationQuat(th,k);
qinv=q.Conjugate(q);

k1q=[[0],[1],[0],[0]];
k2q=[[0],[0],[1],[0]];

t1=time.get();
while t<runtime do
t++;

g.text(20,20,'algorithm 4');

k1q=q.Prod(q,q.Prod(k1q,qinv));
k2q=q.Prod(q,q.Prod(k2q,qinv));

k1=[k1q[1],k1q[2],k1q[3]];
k2=[k2q[1],k2q[2],k2q[3]];

for i=0 to len(points)-1 do
g.put(
sx+ma.dotprod(points[i],k1),
sy+ma.dotprod(points[i],k2),
g.white);
end;

g.show();
sleep(0);
g.clear();

end;


t2=time.get();
print 'algorithm four',t2-t1;

